diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 9e953dda8..858c08536 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -20,30 +20,29 @@ import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.util.debug.Debug;
 import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
 import net.minecraft.core.Global;
-import net.minecraft.core.HitResult;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.BlockSound;
-import net.minecraft.core.sound.BlockSoundDispatcher;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
@@ -68,22 +67,23 @@ import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.WeatherManager;
+import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.Nullable;
 
 public class World implements WorldSource {
 
     public static boolean AUTOSAVE = true;
 
-    private final int heightBlocks = 256;
-    private final int heightBits = -1;
+    public static final int HEIGHT_BLOCKS = 256;
+    public static final int MAX_BRIGHTNESS = 15;
     private final List<LightUpdate> lightingToUpdate = new LinkedList<>();
     public List<Entity> loadedEntityList = new ArrayList<>();
     private final List<Entity> unloadedEntityList = new ArrayList<>();
     private final TreeSet<NextTickListEntry> scheduledTickTreeSet = new TreeSet<>();
     private final Set<NextTickListEntry> scheduledTickSet = new HashSet<>();
-    public List<TileEntity> loadedTileEntityList = new ArrayList<>();
-    private final List<TileEntity> field_30900_E = new ArrayList<>();
-    public List<EntityPlayer> players = new ArrayList<>();
+    public List<BlockEntity> loadedBlockEntityList = new ArrayList<>();
+    private final List<BlockEntity> field_30900_E = new ArrayList<>();
+    public List<Player> players = new ArrayList<>();
     public List<Entity> weatherEffects = new ArrayList<>();
     public final ArrayList<AABB> collidingBoundingBoxes = new ArrayList<>();
     public List<LevelListener> listeners = new ArrayList<>();
@@ -205,7 +205,7 @@ public class World implements WorldSource {
 
         auroraProvider = new AuroraProvider(this, seed);
 
-        seasonManager = SeasonManager.fromConfig(this, this.worldType.getDefaultSeasonConfig());
+        seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
 
         biomeProvider = this.worldType.createBiomeProvider(this);
         
@@ -248,7 +248,7 @@ public class World implements WorldSource {
         savedDataStorage = new SavedDataStorage(saveHandler);
         this.dimension = dimension;
         chunkProvider = createChunkProvider();
-        seasonManager = SeasonManager.fromConfig(this, this.worldType.getDefaultSeasonConfig());
+        seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
 
         biomeProvider = this.worldType.createBiomeProvider(this);
 
@@ -268,7 +268,7 @@ public class World implements WorldSource {
         this.worldType = worldType;
         savedDataStorage = new SavedDataStorage(saveHandler);
         chunkProvider = createChunkProvider();
-        seasonManager = SeasonManager.fromConfig(this, this.worldType.getDefaultSeasonConfig());
+        seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
         updateSkyBrightness();
 
         this.weatherManager = new WeatherManager(this);
@@ -284,7 +284,7 @@ public class World implements WorldSource {
         levelData = new LevelData(0, "modelviewer");
         this.worldType = WorldTypes.DEBUG;
         chunkProvider = new ChunkProviderViewer(this);
-        seasonManager = SeasonManager.fromConfig(this, this.worldType.getDefaultSeasonConfig());
+        seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
         updateSkyBrightness();
 
         this.weatherManager = new WeatherManager(this);
@@ -337,7 +337,7 @@ public class World implements WorldSource {
         return getBlockId(x, y, z);
     }
 
-    public void spawnPlayerWithLoadedChunks(EntityPlayer player)
+    public void spawnPlayerWithLoadedChunks(Player player)
     {
         try
         {
@@ -913,7 +913,7 @@ public class World implements WorldSource {
     {
         if(i < 0xfe17b800 || k < 0xfe17b800 || i >= 0x1e84800 || k > 0x1e84800)
         {
-            return 15;
+            return MAX_BRIGHTNESS;
         }
         if(flag)
         {
@@ -1014,7 +1014,7 @@ public class World implements WorldSource {
         {
             if(canExistingBlockSeeTheSky(x, y, z))
             {
-                lightValue = 15;
+                lightValue = MAX_BRIGHTNESS;
             }
         }
         else if(lightLayer == LightLayer.Block)
@@ -1130,34 +1130,34 @@ public class World implements WorldSource {
     }
 
     @Nullable
-    public HitResult checkBlockCollisionBetweenPoints(Vec3d start, Vec3d end)
+    public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end)
     {
         return checkBlockCollisionBetweenPoints(start, end, false, false);
     }
 
     @Nullable
-    public HitResult checkBlockCollisionBetweenPoints(Vec3d start, Vec3d end, boolean shouldCollideWithFluids)
+    public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids)
     {
         return checkBlockCollisionBetweenPoints(start, end, shouldCollideWithFluids, false);
     }
 
     @Nullable
-    public HitResult checkBlockCollisionBetweenPoints(Vec3d start, Vec3d end, boolean shouldCollideWithFluids, boolean flag1)
+    public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids, boolean flag1)
     {
-        if(Double.isNaN(start.xCoord) || Double.isNaN(start.yCoord) || Double.isNaN(start.zCoord))
+        if(Double.isNaN(start.x) || Double.isNaN(start.y) || Double.isNaN(start.z))
         {
             return null;
         }
-        if(Double.isNaN(end.xCoord) || Double.isNaN(end.yCoord) || Double.isNaN(end.zCoord))
+        if(Double.isNaN(end.x) || Double.isNaN(end.y) || Double.isNaN(end.z))
         {
             return null;
         }
-        int blockEndX = MathHelper.floor_double(end.xCoord);
-        int blockEndY = MathHelper.floor_double(end.yCoord);
-        int blockEndZ = MathHelper.floor_double(end.zCoord);
-        int blockStartX = MathHelper.floor_double(start.xCoord);
-        int blockStartY = MathHelper.floor_double(start.yCoord);
-        int blockStartZ = MathHelper.floor_double(start.zCoord);
+        int blockEndX = MathHelper.floor(end.x);
+        int blockEndY = MathHelper.floor(end.y);
+        int blockEndZ = MathHelper.floor(end.z);
+        int blockStartX = MathHelper.floor(start.x);
+        int blockStartY = MathHelper.floor(start.y);
+        int blockStartZ = MathHelper.floor(start.z);
         int id = getBlockId(blockStartX, blockStartY, blockStartZ);
         int meta = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
         Block block = Block.blocksList[id];
@@ -1171,7 +1171,7 @@ public class World implements WorldSource {
         }
         for(int l1 = 200; l1-- >= 0;)
         {
-            if(Double.isNaN(start.xCoord) || Double.isNaN(start.yCoord) || Double.isNaN(start.zCoord))
+            if(Double.isNaN(start.x) || Double.isNaN(start.y) || Double.isNaN(start.z))
             {
                 return null;
             }
@@ -1221,20 +1221,20 @@ public class World implements WorldSource {
             double d3 = 999D;
             double d4 = 999D;
             double d5 = 999D;
-            double d6 = end.xCoord - start.xCoord;
-            double d7 = end.yCoord - start.yCoord;
-            double d8 = end.zCoord - start.zCoord;
+            double d6 = end.x - start.x;
+            double d7 = end.y - start.y;
+            double d8 = end.z - start.z;
             if(flag2)
             {
-                d3 = (d - start.xCoord) / d6;
+                d3 = (d - start.x) / d6;
             }
             if(flag3)
             {
-                d4 = (d1 - start.yCoord) / d7;
+                d4 = (d1 - start.y) / d7;
             }
             if(flag4)
             {
-                d5 = (d2 - start.zCoord) / d8;
+                d5 = (d2 - start.z) / d8;
             }
             byte byte0 = 0;
             if(d3 < d4 && d3 < d5)
@@ -1246,9 +1246,9 @@ public class World implements WorldSource {
                 {
                     byte0 = 5;
                 }
-                start.xCoord = d;
-                start.yCoord += d7 * d3;
-                start.zCoord += d8 * d3;
+                start.x = d;
+                start.y += d7 * d3;
+                start.z += d8 * d3;
             } else
             if(d4 < d5)
             {
@@ -1259,9 +1259,9 @@ public class World implements WorldSource {
                 {
                     byte0 = 1;
                 }
-                start.xCoord += d6 * d4;
-                start.yCoord = d1;
-                start.zCoord += d8 * d4;
+                start.x += d6 * d4;
+                start.y = d1;
+                start.z += d8 * d4;
             } else
             {
                 if(blockEndZ > blockStartZ)
@@ -1271,28 +1271,28 @@ public class World implements WorldSource {
                 {
                     byte0 = 3;
                 }
-                start.xCoord += d6 * d5;
-                start.yCoord += d7 * d5;
-                start.zCoord = d2;
+                start.x += d6 * d5;
+                start.y += d7 * d5;
+                start.z = d2;
             }
-            Vec3d vec3d2 = Vec3d.createVector(start.xCoord, start.yCoord, start.zCoord);
-            blockStartX = (int)(vec3d2.xCoord = MathHelper.floor_double(start.xCoord));
+            Vec3 vec32 = Vec3.getTempVec3(start.x, start.y, start.z);
+            blockStartX = (int)(vec32.x = MathHelper.floor(start.x));
             if(byte0 == 5)
             {
                 blockStartX--;
-                vec3d2.xCoord++;
+                vec32.x++;
             }
-            blockStartY = (int)(vec3d2.yCoord = MathHelper.floor_double(start.yCoord));
+            blockStartY = (int)(vec32.y = MathHelper.floor(start.y));
             if(byte0 == 1)
             {
                 blockStartY--;
-                vec3d2.yCoord++;
+                vec32.y++;
             }
-            blockStartZ = (int)(vec3d2.zCoord = MathHelper.floor_double(start.zCoord));
+            blockStartZ = (int)(vec32.z = MathHelper.floor(start.z));
             if(byte0 == 3)
             {
                 blockStartZ--;
-                vec3d2.zCoord++;
+                vec32.z++;
             }
             int j2 = getBlockId(blockStartX, blockStartY, blockStartZ);
             int k2 = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
@@ -1332,7 +1332,7 @@ public class World implements WorldSource {
     {
         if (block == null) return;
 
-        BlockSound sound = BlockSoundDispatcher.getInstance().getDispatch(block);
+        BlockSound sound = block.getSound();
         if (sound == null) return;
 
         String name;
@@ -1386,14 +1386,14 @@ public class World implements WorldSource {
 
     public boolean entityJoinedWorld(Entity entity)
     {
-        int i = MathHelper.floor_double(entity.x / Chunk.CHUNK_SIZE_X);
-        int j = MathHelper.floor_double(entity.z / Chunk.CHUNK_SIZE_Z);
-        boolean flag = entity instanceof EntityPlayer;
+        int i = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
+        int j = MathHelper.floor(entity.z / Chunk.CHUNK_SIZE_Z);
+        boolean flag = entity instanceof Player;
         if(flag || isChunkLoaded(i, j))
         {
-            if(entity instanceof EntityPlayer)
+            if(entity instanceof Player)
             {
-                EntityPlayer entityplayer = (EntityPlayer)entity;
+                Player entityplayer = (Player)entity;
                 players.add(entityplayer);
                 updateEnoughPlayersSleepingFlag(null);
             }
@@ -1437,9 +1437,9 @@ public class World implements WorldSource {
             entity.startRiding(null);
         }
         entity.remove();
-        if(entity instanceof EntityPlayer)
+        if(entity instanceof Player)
         {
-            players.remove((EntityPlayer)entity);
+            players.remove((Player)entity);
             updateEnoughPlayersSleepingFlag(null);
         }
     }
@@ -1447,9 +1447,9 @@ public class World implements WorldSource {
     public void removePlayer(Entity entity)
     {
         entity.remove();
-        if(entity instanceof EntityPlayer)
+        if(entity instanceof Player)
         {
-            players.remove((EntityPlayer)entity);
+            players.remove((Player)entity);
             updateEnoughPlayersSleepingFlag(null);
         }
         int i = entity.chunkCoordX;
@@ -1475,12 +1475,12 @@ public class World implements WorldSource {
     {
         collidingBoundingBoxes.clear();
 
-        int minX = MathHelper.floor_double(axisalignedbb.minX);
-        int maxX = MathHelper.floor_double(axisalignedbb.maxX + 1.0D);
-        int minY = MathHelper.floor_double(axisalignedbb.minY);
-        int maxY = MathHelper.floor_double(axisalignedbb.maxY + 1.0D);
-        int minZ = MathHelper.floor_double(axisalignedbb.minZ);
-        int maxZ = MathHelper.floor_double(axisalignedbb.maxZ + 1.0D);
+        int minX = MathHelper.floor(axisalignedbb.minX);
+        int maxX = MathHelper.floor(axisalignedbb.maxX + 1.0D);
+        int minY = MathHelper.floor(axisalignedbb.minY);
+        int maxY = MathHelper.floor(axisalignedbb.maxY + 1.0D);
+        int minZ = MathHelper.floor(axisalignedbb.minZ);
+        int maxZ = MathHelper.floor(axisalignedbb.maxZ + 1.0D);
         for(int dx = minX - 1; dx <= maxX; dx++)
         {
             for(int dz = minZ - 1; dz <= maxZ; dz++)
@@ -1507,10 +1507,10 @@ public class World implements WorldSource {
         }
 
         double radius = 0.25D;
-        List<Entity> list = getEntitiesWithinAABBExcludingEntity(entity, axisalignedbb.expand(radius, radius, radius));
+        List<Entity> list = getEntitiesWithinAABBExcludingEntity(entity, axisalignedbb.grow(radius, radius, radius));
         for (Entity value : list) {
             AABB axisalignedbb1 = value.getBb();
-            if (axisalignedbb1 != null && axisalignedbb1.intersectsWith(axisalignedbb)) {
+            if (axisalignedbb1 != null && axisalignedbb1.intersects(axisalignedbb)) {
                 collidingBoundingBoxes.add(axisalignedbb1);
             }
         }
@@ -1521,12 +1521,12 @@ public class World implements WorldSource {
     public List<AABB> getCollidingSolidBlockBoundingBoxes(Entity entity, AABB axisalignedbb)
     {
         collidingBoundingBoxes.clear();
-        int minX = MathHelper.floor_double(axisalignedbb.minX);
-        int maxX = MathHelper.floor_double(axisalignedbb.maxX + 1.0D);
-        int minY = MathHelper.floor_double(axisalignedbb.minY);
-        int maxY = MathHelper.floor_double(axisalignedbb.maxY + 1.0D);
-        int minZ = MathHelper.floor_double(axisalignedbb.minZ);
-        int maxZ = MathHelper.floor_double(axisalignedbb.maxZ + 1.0D);
+        int minX = MathHelper.floor(axisalignedbb.minX);
+        int maxX = MathHelper.floor(axisalignedbb.maxX + 1.0D);
+        int minY = MathHelper.floor(axisalignedbb.minY);
+        int maxY = MathHelper.floor(axisalignedbb.maxY + 1.0D);
+        int minZ = MathHelper.floor(axisalignedbb.minZ);
+        int maxZ = MathHelper.floor(axisalignedbb.maxZ + 1.0D);
         for(int dx = minX - 1; dx <= maxX; dx++)
         {
             for(int dz = minZ - 1; dz <= maxZ; dz++)
@@ -1541,7 +1541,7 @@ public class World implements WorldSource {
                     if(block != null && block.isSolidRender())
                     {
                         // ignore mesh blocks if entity is instance of an item
-                        if(!(entity instanceof EntityItem && (block.id == Block.mesh.id || block.id == Block.spikes.id || block.id == Block.mobspawner.id)))
+                        if(!(entity instanceof ItemEntity && (block.id == Blocks.MESH.id || block.id == Blocks.SPIKES.id || block.id == Blocks.MOBSPAWNER.id)))
                             block.getCollidingBoundingBoxes(this, dx, dy, dz, axisalignedbb, collidingBoundingBoxes);
                     }
                 }
@@ -1551,11 +1551,11 @@ public class World implements WorldSource {
         }
 
         double d = 0.25D;
-        List list = getEntitiesWithinAABBExcludingEntity(entity, axisalignedbb.expand(d, d, d));
+        List list = getEntitiesWithinAABBExcludingEntity(entity, axisalignedbb.grow(d, d, d));
         for(int j2 = 0; j2 < list.size(); j2++)
         {
             AABB axisalignedbb1 = ((Entity)list.get(j2)).getBb();
-            if(axisalignedbb1 != null && axisalignedbb1.intersectsWith(axisalignedbb))
+            if(axisalignedbb1 != null && axisalignedbb1.intersects(axisalignedbb))
             {
                 collidingBoundingBoxes.add(axisalignedbb1);
             }
@@ -1566,17 +1566,17 @@ public class World implements WorldSource {
 	
 	public float getAmbientBrightness(float partialTicks) {
 		float angle = getCelestialAngle(partialTicks);
-		float bright = 1.0F - (MathHelper.cos(angle * 3.141593F * 2.0F) * 2.0F + 0.2F);
+		float bright = 1.0F - (MathHelper.cos(angle * MathHelper.PI * 2.0F) * 2.0F + 0.2F);
 		bright = 1.0f - MathHelper.clamp(bright, 0.0f, 1.0f);
 		
 		Weather weather = weatherManager.getCurrentWeather();
 		if(weather != null) {
 			// TODO Unhardcode somehow
-			if(weather == Weather.overworldRain) {
+			if(weather == Weathers.OVERWORLD_RAIN) {
 				float power = weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower();
 				bright = (float) (bright * (1.0 - (power * 5.0f) / 16.0));	
 			}
-			if(weather == Weather.overworldStorm) {
+			if(weather == Weathers.OVERWORLD_STORM) {
 				float power = weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower();
 				bright = (float) (bright * (1.0 - (power * 5.0f) / 16.0));
 				bright = (float) (bright * (1.0 - (power * 5.0f) / 16.0));
@@ -1586,10 +1586,10 @@ public class World implements WorldSource {
 		return bright * 0.8f + 0.2f;
 	}
 
-    public Vec3d getSkyColor(ICamera camera, float partialTick)
+    public Vec3 getSkyColor(ICamera camera, float partialTick)
     {
         float f1 = getCelestialAngle(partialTick);
-        float f2 = MathHelper.cos(f1 * 3.141593F * 2.0F) * 2.0F + 0.5F;
+        float f2 = MathHelper.cos(f1 * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
         if(f2 < 0.0F)
         {
             f2 = 0.0F;
@@ -1598,9 +1598,9 @@ public class World implements WorldSource {
         {
             f2 = 1.0F;
         }
-        int x = MathHelper.floor_double(camera.getX(partialTick));
-        int y = MathHelper.floor_double(camera.getY(partialTick));
-        int z = MathHelper.floor_double(camera.getZ(partialTick));
+        int x = MathHelper.floor(camera.getX(partialTick));
+        int y = MathHelper.floor(camera.getY(partialTick));
+        int z = MathHelper.floor(camera.getZ(partialTick));
         float blockTemperature = (float) getBlockTemperature(x, z);
 
         if (seasonManager.getCurrentSeason() != null && (seasonManager.getCurrentSeason() == Seasons.OVERWORLD_WINTER || seasonManager.getCurrentSeason() == Seasons.OVERWORLD_FALL))
@@ -1640,7 +1640,7 @@ public class World implements WorldSource {
             g = g * (1.0F - f12) + 0.8F * f12;
             b = b * (1.0F - f12) + f12;
         }
-        return Vec3d.createVector(r, g, b);
+        return Vec3.getTempVec3(r, g, b);
     }
 
     public float getCelestialAngle(float partialTick)
@@ -1651,10 +1651,10 @@ public class World implements WorldSource {
         return worldType.getCelestialAngle(this, levelData.getWorldTime(), partialTick);
     }
 
-    public Vec3d getDimensionColor(ICamera camera, float partialTick)
+    public Vec3 getDimensionColor(ICamera camera, float partialTick)
     {
         float f1 = getCelestialAngle(partialTick);
-        float f2 = MathHelper.cos(f1 * 3.141593F * 2.0F) * 2.0F + 0.5F;
+        float f2 = MathHelper.cos(f1 * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
         if(f2 < 0.0F)
         {
             f2 = 0.0F;
@@ -1679,10 +1679,10 @@ public class World implements WorldSource {
         r *= f2 * 0.9F + 0.1F;
         g *= f2 * 0.9F + 0.1F;
         b *= f2 * 0.85F + 0.15F;
-        return Vec3d.createVector(r, g, b);
+        return Vec3.getTempVec3(r, g, b);
     }
 
-    public Vec3d getFogColor(ICamera camera, float partialTick)
+    public Vec3 getFogColor(ICamera camera, float partialTick)
     {
     	double x = camera.getX(partialTick);
     	double y = camera.getY(partialTick);
@@ -1737,7 +1737,7 @@ public class World implements WorldSource {
     public float getStarBrightness(float partialTick)
     {
         float f1 = getCelestialAngle(partialTick);
-        float f2 = 1.0F - (MathHelper.cos(f1 * 3.141593F * 2.0F) * 2.0F + 0.75F);
+        float f2 = 1.0F - (MathHelper.cos(f1 * MathHelper.PI * 2.0F) * 2.0F + 0.75F);
         if(f2 < 0.0F)
         {
             f2 = 0.0F;
@@ -1835,14 +1835,14 @@ public class World implements WorldSource {
         }
 
         field_31055_L = true;
-        Iterator iterator = loadedTileEntityList.iterator();
+        Iterator iterator = loadedBlockEntityList.iterator();
         do
         {
             if(!iterator.hasNext())
             {
                 break;
             }
-            TileEntity tileentity = (TileEntity)iterator.next();
+            BlockEntity tileentity = (BlockEntity)iterator.next();
             if(!tileentity.isInvalid() && isBlockLoaded(tileentity.x, tileentity.y, tileentity.z))
             {
                 tileentity.tick();
@@ -1853,7 +1853,7 @@ public class World implements WorldSource {
                 Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(tileentity.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(tileentity.z, Chunk.CHUNK_SIZE_Z));
                 if(chunk != null)
                 {
-                    chunk.removeTileEntity(tileentity.x & (Chunk.CHUNK_SIZE_X - 1), tileentity.y, tileentity.z & (Chunk.CHUNK_SIZE_Z - 1));
+                    chunk.removeBlockEntity(tileentity.x & (Chunk.CHUNK_SIZE_X - 1), tileentity.y, tileentity.z & (Chunk.CHUNK_SIZE_Z - 1));
                 }
             }
         } while(true);
@@ -1867,17 +1867,17 @@ public class World implements WorldSource {
                 {
                     break;
                 }
-                TileEntity tileentity1 = (TileEntity)iterator1.next();
+                BlockEntity tileentity1 = (BlockEntity)iterator1.next();
                 if(!tileentity1.isInvalid())
                 {
-                    if(!loadedTileEntityList.contains(tileentity1))
+                    if(!loadedBlockEntityList.contains(tileentity1))
                     {
-                        loadedTileEntityList.add(tileentity1);
+                        loadedBlockEntityList.add(tileentity1);
                     }
                     Chunk chunk1 = getChunkFromChunkCoords(Math.floorDiv(tileentity1.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(tileentity1.z, Chunk.CHUNK_SIZE_Z));
                     if(chunk1 != null)
                     {
-                        chunk1.setTileEntity(tileentity1.x & (Chunk.CHUNK_SIZE_X - 1), tileentity1.y, tileentity1.z & (Chunk.CHUNK_SIZE_Z - 1), tileentity1);
+                        chunk1.setBlockEntity(tileentity1.x & (Chunk.CHUNK_SIZE_X - 1), tileentity1.y, tileentity1.z & (Chunk.CHUNK_SIZE_Z - 1), tileentity1);
                     }
                     markBlockNeedsUpdate(tileentity1.x, tileentity1.y, tileentity1.z);
                 }
@@ -1886,14 +1886,14 @@ public class World implements WorldSource {
         }
     }
 
-    public void func_31054_a(Collection collection)
+    public void addAllBlockEntities(Collection<BlockEntity> blockEntities)
     {
         if(field_31055_L)
         {
-            field_30900_E.addAll(collection);
+            field_30900_E.addAll(blockEntities);
         } else
         {
-            loadedTileEntityList.addAll(collection);
+            loadedBlockEntityList.addAll(blockEntities);
         }
     }
 
@@ -1904,14 +1904,14 @@ public class World implements WorldSource {
 
     public void updateEntityWithOptionalForce(Entity entity, boolean flag)
     {
-        int i = MathHelper.floor_double(entity.x);
-        int j = MathHelper.floor_double(entity.z);
+        int i = MathHelper.floor(entity.x);
+        int j = MathHelper.floor(entity.z);
         byte byte0 = 32;
         if(flag && !areBlocksLoaded(i - byte0, 0, j - byte0, i + byte0, getHeightBlocks(), j + byte0))
         {
             //try to despawn if entity wanders into nonexistant chunk
-            if(entity instanceof EntityLiving) {
-                ((EntityLiving) entity).tryToDespawn();
+            if(entity instanceof Mob) {
+                ((Mob) entity).tryToDespawn();
             }
             return;
         }
@@ -1950,9 +1950,9 @@ public class World implements WorldSource {
         {
             entity.yRot = entity.yRotO;
         }
-        int k = MathHelper.floor_double(entity.x / Chunk.CHUNK_SIZE_X);
-        int l = MathHelper.floor_double(entity.y / 16D);
-        int i1 = MathHelper.floor_double(entity.z / Chunk.CHUNK_SIZE_Z);
+        int k = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
+        int l = MathHelper.floor(entity.y / 16D);
+        int i1 = MathHelper.floor(entity.z / Chunk.CHUNK_SIZE_Z);
         if(!entity.addedToChunk || entity.chunkCoordX != k || entity.chunkCoordY != l || entity.chunkCoordZ != i1)
         {
             if(entity.addedToChunk && isChunkLoaded(entity.chunkCoordX, entity.chunkCoordZ))
@@ -1988,7 +1988,7 @@ public class World implements WorldSource {
         for(int i = 0; i < list.size(); i++)
         {
             Entity entity = (Entity)list.get(i);
-            if (entity instanceof EntityFireflyCluster) continue;
+            if (entity instanceof FireflyClusterMob) continue;
             if(!entity.removed && entity.blocksBuilding)
             {
                 return false;
@@ -1999,12 +1999,12 @@ public class World implements WorldSource {
     }
     
 	public boolean getIsAnySolidGround(AABB boundingBox) {
-		int minX = MathHelper.floor_double(boundingBox.minX);
-		int maxX = MathHelper.floor_double(boundingBox.maxX);
-		int minY = MathHelper.floor_double(boundingBox.minY);
-		int maxY = MathHelper.floor_double(boundingBox.maxY);
-		int minZ = MathHelper.floor_double(boundingBox.minZ);
-		int maxZ = MathHelper.floor_double(boundingBox.maxZ);
+		int minX = MathHelper.floor(boundingBox.minX);
+		int maxX = MathHelper.floor(boundingBox.maxX);
+		int minY = MathHelper.floor(boundingBox.minY);
+		int maxY = MathHelper.floor(boundingBox.maxY);
+		int minZ = MathHelper.floor(boundingBox.minZ);
+		int maxZ = MathHelper.floor(boundingBox.maxZ);
 		
 		for(int x = minX; x <= maxX; x++) {
 			for(int y = minY; y <= maxY; y++) {
@@ -2021,7 +2021,7 @@ public class World implements WorldSource {
 
         for (Entity entity : entities) {
             AABB axisalignedbb1 = entity.getBb();
-            if (axisalignedbb1 != null && axisalignedbb1.intersectsWith(boundingBox)) {
+            if (axisalignedbb1 != null && axisalignedbb1.intersects(boundingBox)) {
                 collidingBoundingBoxes.add(axisalignedbb1);
             }
         }
@@ -2031,12 +2031,12 @@ public class World implements WorldSource {
 
 
 	public boolean getIsAnyLiquid(AABB boundingBox) {
-		int minX = MathHelper.floor_double(boundingBox.minX);
-		int maxX = MathHelper.floor_double(boundingBox.maxX);
-		int minY = MathHelper.floor_double(boundingBox.minY);
-		int maxY = MathHelper.floor_double(boundingBox.maxY);
-		int minZ = MathHelper.floor_double(boundingBox.minZ);
-		int maxZ = MathHelper.floor_double(boundingBox.maxZ);
+		int minX = MathHelper.floor(boundingBox.minX);
+		int maxX = MathHelper.floor(boundingBox.maxX);
+		int minY = MathHelper.floor(boundingBox.minY);
+		int maxY = MathHelper.floor(boundingBox.maxY);
+		int minZ = MathHelper.floor(boundingBox.minZ);
+		int maxZ = MathHelper.floor(boundingBox.maxZ);
 
 		for(int x = minX; x <= maxX; x++) {
 			for(int y = minY; y <= maxY; y++) {
@@ -2059,18 +2059,18 @@ public class World implements WorldSource {
 
     public boolean handleMaterialAcceleration(AABB axisalignedbb, Material material, Entity entity, boolean addVelocity)
     {
-        int i = MathHelper.floor_double(axisalignedbb.minX);
-        int j = MathHelper.floor_double(axisalignedbb.maxX + 1.0D);
-        int k = MathHelper.floor_double(axisalignedbb.minY);
-        int l = MathHelper.floor_double(axisalignedbb.maxY + 1.0D);
-        int i1 = MathHelper.floor_double(axisalignedbb.minZ);
-        int j1 = MathHelper.floor_double(axisalignedbb.maxZ + 1.0D);
+        int i = MathHelper.floor(axisalignedbb.minX);
+        int j = MathHelper.floor(axisalignedbb.maxX + 1.0D);
+        int k = MathHelper.floor(axisalignedbb.minY);
+        int l = MathHelper.floor(axisalignedbb.maxY + 1.0D);
+        int i1 = MathHelper.floor(axisalignedbb.minZ);
+        int j1 = MathHelper.floor(axisalignedbb.maxZ + 1.0D);
         if(!areBlocksLoaded(i, k, i1, j, l, j1))
         {
             return false;
         }
         boolean flag = false;
-        Vec3d vec3d = Vec3d.createVector(0.0D, 0.0D, 0.0D);
+        Vec3 vec3 = Vec3.getTempVec3(0.0D, 0.0D, 0.0D);
         for(int k1 = i; k1 < j; k1++)
         {
             for(int l1 = k; l1 < l; l1++)
